package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.WFUserAssistMapper;
import com.sa.ibiz.demo.demo.domain.WFUserAssist;
import com.sa.ibiz.demo.demo.service.WFUserAssistService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.WFUserAssistSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.WFUserService;
import com.sa.ibiz.demo.demo.service.WFUserService;
import com.sa.ibiz.demo.demo.service.WFWorkflowService;

/**
 * 实体[WFUserAssist] 服务对象接口实现
 */
@Service
public class WFUserAssistServiceImpl extends ServiceImplBase<WFUserAssistMapper, WFUserAssist> implements WFUserAssistService{

    @Autowired
    private WFUserService wfmajoruserService;
    @Autowired
    private WFUserService wfminoruserService;
    @Autowired
    private WFWorkflowService wfworkflowService;

    @Resource
    private WFUserAssistMapper wfuserassistMapper;


    @Override
    public boolean create(WFUserAssist et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(WFUserAssist et){
        this.beforeUpdate(et);
		this.wfuserassistMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(WFUserAssist et){
		return et.getWfuserassistid();  
    }

    @Override
    public boolean getDraft(WFUserAssist et)  {
    if((!StringUtils.isEmpty(et.getWfmajoruserid())) && et.getWfmajoruser() == null){
            try {
                et.setWfmajoruser(wfmajoruserService.getById(et.getWfmajoruserid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getWfminoruserid())) && et.getWfminoruser() == null){
            try {
                et.setWfminoruser(wfminoruserService.getById(et.getWfminoruserid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getWfworkflowid())) && et.getWfworkflow() == null){
            try {
                et.setWfworkflow(wfworkflowService.getById(et.getWfworkflowid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<WFUserAssist> listDefault(WFUserAssistSearchFilter filter) {
		return wfuserassistMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<WFUserAssist> searchDefault(WFUserAssistSearchFilter filter) {
		return wfuserassistMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return wfuserassistMapper.selectRow(sql);
    }

 }